package model

import (
	"github.com/shopspring/decimal"
	"github.com/uptrace/bun"
)

type WillDilutedFee struct {
	bun.BaseModel      `bun:"table:will_diluted_fee,alias:w"`
	CreatedAndModified `bun:"extend"`
	Id                 string          `bun:",pk,notnull" json:"diluteId"`
	ReportId           string          `bun:",notnull" json:"reportId"`
	SourceId           *string         `json:"sourceId"`
	Name               string          `bun:",notnull" json:"name"`
	Fee                decimal.Decimal `bun:",notnull,default:0" json:"fee"`
	Memo               *string         `bun:"type:text" json:"memo"`
	Origin             *MaintenanceFee `bun:"rel:belongs-to,join:source_id=id"`
}
